// ----------------------------------------------------------------------------
// This chatter client use the example from the book _Java in a Nutshell_ by 
// David Flanagan as a start point, but much different.
// Following is the description about the example.
// ----------------------------------------------------------------------------
// This example is from the book _Java in a Nutshell_ by David Flanagan.
// Written by David Flanagan.  Copyright (c) 1996 O'Reilly & Associates.
// You may study, use, modify, and distribute this example for any purpose.
// This example is provided WITHOUT WARRANTY either expressed or implied.
// ----------------------------------------------------------------------------

import java.awt.*;
// import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.applet.*;

public class chatter extends Applet{ 
    public static final int PORT = 2222;
    Socket s;
    DataInputStream in;
    PrintStream out;
    StreamListener listener;

    TextField inputfield;
	String inputString = new String("anonymous");
    TextArea outputarea;
    Button sendName, lstRm, lstUsr, exitRm;
	Panel buttonpanel;

    // Create a socket to communicate with a server on port 2222 of the
    // host that the applet's code is on.  Create streams to use with
    // the socket.  Then create a TextField for user input and a TextArea
    // for server output.  Finally, create a thread to wait for and 
    // display server output.
    public void init() {
        try {
            s = new Socket(this.getCodeBase().getHost(), PORT);
            in = new DataInputStream(s.getInputStream());
            out = new PrintStream(s.getOutputStream());

            inputfield = new TextField();
            outputarea = new TextArea();
            outputarea.setEditable(false);
            this.setLayout(new BorderLayout());
            this.add("North", inputfield);
            this.add("Center", outputarea);

			/* buttonpanel = new Panel();
			buttonpanel.setLayout(new GridLayout(10, 1));

			sendName = new Button("SendName");
			sendName.addActionListener(this);
			buttonpanel.add(sendName);

			lstRm = new Button("ListRoom");
			lstRm.addActionListener(this);
			buttonpanel.add(lstRm);

			lstUsr = new Button("ListUser");
			lstUsr.addActionListener(this);
			buttonpanel.add(lstUsr);

			exitRm = new Button("ExitRoom");
			exitRm.addActionListener(this);
			buttonpanel.add(exitRm);

			this.add("East", buttonpanel); */
            
            listener = new StreamListener(in, outputarea);

            this.showStatus("Connected to " 
                    + s.getInetAddress().getHostName() 
                    + ":" + s.getPort());
        }
        catch (IOException e) { this.showStatus(e.toString()); }
    }
    
    // When the user types a line, send it to the server.
    public boolean action(Event e, Object what) {
        if (e.target == inputfield) {
			inputString = (String) e.arg;
            out.println((String)e.arg);
            inputfield.setText("");
            return true;
        }
        return false;
    }

    /* public void actionPerformed(ActionEvent evt) {
		if(evt.getActionCommand() == "SendName") {
			out.println("/n" + inputString);	
        	return;
		} else if(evt.getActionCommand() == "ListRoom"){
			out.println("/r");	
        	return;
		} else if(evt.getActionCommand() == "Listuser") {
			out.println("/u");	
        	return;
		} else if(evt.getActionCommand() == "ExitRoom") {
			out.println("/q");	
        	return;
		} else return;
	} */
}

// Wait for output from the server on the specified stream, and display
// it in the specified TextArea.
class StreamListener extends Thread {
    DataInputStream in;
    TextArea output;
    public StreamListener(DataInputStream in, TextArea output) {
        this.in = in;
        this.output = output;
        this.start();
    }
    public void run() {
        String line;
        try {
            for(;;) {
                line = in.readLine();
                if (line == null) break;
                output.appendText(line + "\n");
            }
        }
        catch (IOException e) { output.appendText(e.toString()); }
        finally { output.setText("Connection lost."); }
    }
}
